/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package de.boreeas.motd.main;

import com.nijiko.permissions.PermissionHandler;
import com.nijikokun.bukkit.Permissions.Permissions;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import org.bukkit.ChatColor;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.event.Event;
import org.bukkit.plugin.Plugin;
import org.bukkit.plugin.PluginManager;
import org.bukkit.plugin.java.JavaPlugin;

/**
 *
 * @author Malte
 */
public class MOTD extends JavaPlugin {
    
    public static final Logger logger = Logger.getLogger("Minecraft");
    private static String name = "[MOTD]";
    private static String version = "v1.1.2";

    private String[] commands = {ChatColor.RED + "/motd " + ChatColor.GOLD + "- Displays MOTD",
                                ChatColor.RED + "/motd help " + ChatColor.GOLD + "- Displays this help",
                                ChatColor.RED + "/motd set [rank] [message] " + ChatColor.GOLD + "- Sets MOTD for specified rank"};
    
    private final MOTDPlayerListener playerJoinListener = new MOTDPlayerListener(this);
    
    public MOTDParser parser;
    public static PermissionHandler permissionHandler;
    
    @Override
    public void onEnable() {
        
        PluginManager pm = this.getServer().getPluginManager();
        pm.registerEvent(Event.Type.PLAYER_JOIN, playerJoinListener, Event.Priority.Normal, this);
        setupPermissions();
        parser = new MOTDParser(this);
        if (permissionHandler != null) {
            logger.log(Level.INFO, name + " " + version + " succesfully enabled");
        }
    }
    
    @Override
    public void onDisable() {
        logger.log(Level.INFO, name + " " + version + " succesfully disabled");
    }
    
    @Override
    public boolean onCommand(CommandSender sender, Command cmd, String cmdLabel, String[] args) {
        
        boolean isDev = false;
        boolean isOp = false;
        boolean isPlayer = sender instanceof Player;
        if (sender instanceof Player) {

            isDev = ((Player)sender).getName().equalsIgnoreCase("Boreeas");
            isOp = ((Player)sender).isOp();
        }
        
        if (cmd.getName().equalsIgnoreCase("motd")) {
            
            if (args.length == 0) {

                if (isPlayer) {
                    
                    sendToPlayer((Player)sender, parser.getMessage((Player)sender));
                    return true;
                    
                }

            }
            
            else if (args[0].equalsIgnoreCase("set")) {
                
                if (isPlayer) {
                    if (permissionHandler.has((Player) sender, "motd.admin.set") || isDev || isOp) {
                        
                        try {
                            parser.setMOTD(args);
                            sender.sendMessage("Stored MOTD succesfully.");
                        } catch (IOException ioe) {
                            sender.sendMessage("WARNING: Could not save MOTD file. All unsaved changes will be lost at server shutdown (See console for more information).");
                            logger.log(Level.SEVERE, "Could not save MOTD file. All unsaved changes will be lost", ioe);
                        } catch (ArrayIndexOutOfBoundsException oobe) {
                            sender.sendMessage("Missing arguments: /motd set [Rank] [Message]");
                        }
                        
                            
                        
                        return true;
                    }
                }
            }
            
            else {
                
                if (isPlayer) {
                    
                    sendToPlayer((Player)sender, commands);
                    return true;
                }
                return false;
            }
        }
        return false;
    }

    private void setupPermissions() {
        if (permissionHandler != null) {
            return;
        }

        Plugin permissionsPlugin = this.getServer().getPluginManager().getPlugin("Permissions");

        if (permissionsPlugin == null) {
            logger.log(Level.SEVERE, "Permission system not detected, disabling MOTD");
            return;
        }

        permissionHandler = ((Permissions) permissionsPlugin).getHandler();
        log("Found and will use plugin "+((Permissions)permissionsPlugin).getDescription().getFullName());
    }

    public static void log(String string) {
        logger.log(Level.INFO, string);
    }
    
    public PermissionHandler getPermHandler() {
        
        return permissionHandler;
    }
    
    public void sendToPlayer(Player player, String[] args) {
        
        for (String s: args) {
            
            player.sendMessage(s);
        }
    }
}
