package de.boreeas.motd.main;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.logging.Level;

/**
 * @author Malte
 */
public class NewsFileReader {
    
    
    BufferedReader reader;
    MOTD plugin;
    private File dir;
    private File loc;
    
    public NewsFileReader(MOTD instance) throws FileNotFoundException {
        
        plugin = instance;
        
        dir = plugin.getDataFolder();
        loc = new File(dir.getPath() + "/news.txt");
        try {
            reader = new BufferedReader(new InputStreamReader(new FileInputStream(loc)));
        } catch (FileNotFoundException fileNotFoundException) {
            MOTD.logger.log(Level.WARNING, "Could not find news file");
        }
    }
    
    public String readAll() {
        
        
        try {
            String line = null, out = reader.readLine().replace("\n", "").replace("\r", "");
            while ((line = reader.readLine()) != null) {
            
                out += ("%n%" + line);
            }
            
            return out;
        } catch (IOException ioe) {
            
            return null;
        } catch (NullPointerException npe) {
            
            return null;
        }
    }
}
